CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  TX_PIN        = 0
  BAUD          = 9_600
  _clockDataPin = 4
  _clockClockPin = 5

VAR
  byte line
  byte col
  byte rval
  byte answer
  byte dig2[2]
  long useser           'USB serial connection detected T/F
  
OBJ
  rtc           : "DSRTC_driver"
  Debug         : "Extended_FDSerial"  

PUB Main
  useser := false
  if ina[31] == 1                      ' RX (pin 31) is high if USB is connected
    Debug.start(31, 30, 0, 57600)      ' ignore tx echo on rx
    useser := true                     ' Debug serial connection is active 
  waitcnt(clkfreq * 3 + cnt)         ' Pause for FullDuplexSerial.spin to initialize

  rtc.rtcEngineStart(_clockDataPin, _clockClockPin, -1)

  if useser == true
    Debug.tx(16)  'cls
    Prompt(string("Enter 'y' if you want to set clock:"),true)
    answer := Debug.RxTime(5000)
    if answer == "y"
      SetClock
    Debug.tx(16)  'cls
    waitcnt(clkfreq / 100 + cnt)              

  repeat
    rtc.readClock
    if useser == true
      DispTime  
    waitcnt(clkfreq + cnt)            

PUB DispTime
  Debug.Tx(2)              'command to position the cursor at X,Y
  Debug.Tx(0)              'actual X
  Debug.Tx(0)              'actual Y
  SPad(rtc.clockMonth)
  Debug.tx("/")
  SPad(rtc.clockDate)
  Debug.tx("/")
  SPad(rtc.clockYear - 2000)
  Debug.tx(" ")
  Debug.str(rtc.clockDOW)

  Debug.Tx(2)              'command to position the cursor at X,Y....its code is 2
  Debug.Tx(0)              'actual X
  Debug.Tx(1)              'actual Y
  SPad(rtc.clockHour)
  Debug.tx(":")
  SPad(rtc.clockMinute)
  Debug.tx(":")
  SPad(rtc.clockSecond)
  Debug.tx(" ")
  if(rtc.clockAMPM == rtc#PM)
    Debug.str(string("PM"))            
  else
    Debug.str(string("AM"))

PUB SPad(value) | temp
  temp := value
  if temp < 10
    Debug.tx("0")
  Debug.DEC(value)
    
PUB SetClock | time[7], modeind, ampmind, tmp
  Prompt(String("Enter year (00-99)"),true)
  time[6] := getSerVal(2) + 2000
  Prompt(String("Enter month (1-12)"),true)
  time[5] := getSerVal(2)
  Prompt(String("Enter date (1-31)"), true)
  time[4] := getSerVal(2)
  Prompt(String("Enter day of week where 1=SUN 2=MON 3=TUE 4=WED 5=THU 6=FRI 7=SAT"), true)
  time[3] := getSerVal(1)
  Prompt(String("Enter clock mode - 12 or 24"),true)
  tmp := getSerVal(2)
  if tmp == 12
    modeind := rtc#Mode12hr
    Prompt(String("Enter 'a' for AM or 'p' for PM"),true)
    tmp := Debug.Rx
    if tmp == "a"
      ampmind := rtc#AM
    else
      ampmind := rtc#PM 
  else
    modeind := rtc#Mode24hr
  Prompt(String("Enter hour "),false)
  if modeind == rtc#Mode12hr
    Prompt(String("(1-12)"),true)
  else
    Prompt(String("(0-23)"),true)
  time[2] := getSerVal(2)
  Prompt(String("Enter minute (1-59)"),true)
  time[1] := getSerVal(2)
  time[0] := 0
  
  rtc.setClock(modeind, ampmind, time[0],{
                       } time[1], {
                       } time[2], {
                       } time[3], {
                       } time[4], {
                       } time[5], {
                       } time[6])
                       
PRI Prompt(msg, CR)
  Debug.str(msg)
  if CR
    Debug.tx(13)

PUB getSerVal(lim) : value | bytesread, tmp, x, place
  Debug.RxFlush
  bytesread := 0
  value := 0
  place := 1
  
  repeat while bytesread < lim
    tmp := Debug.Rx
    if ((tmp == 10) OR (tmp ==13) OR (tmp == "*"))
      QUIT
    if (tmp => ("0")) and (tmp =< ("9"))  
      dig2[bytesread] := tmp
      bytesread++
  
  repeat x from (bytesread - 1) to 0
    value := value + ((dig2[x]-"0") * place)       
    place := place * 10        
                               